<template>
  <HeaderProductList :category="category" />
  <Filter />
  <ListProduct
    :products="products"
    :category="category"
    :currency="currency"
    :findvalue="findvalue"
    :decrement="decrement"
    :cart="cart"
    :increment="increment"
    :addToCart="addToCart"
  />
  <ButtonToCart :cart="cart" />
</template>

<script>
import axios from "axios";
import ListProduct from "./content/ListProduct.vue";
import Filter from "../filter/Filter.vue";
import HeaderProductList from "./content/Header.vue";
import ButtonToCart from "./content/Button.vue";

let cart = window.localStorage.getItem("cart");

export default {
  name: "ComponentProductList",
  components: {
    ListProduct,
    Filter,
    HeaderProductList,
    ButtonToCart,
  },
  data() {
    return {
      products: [],
      category: "",

      //function list product
      product: this.products,
      quantity: 1,
      updateqty: "",
      cart: cart ? JSON.parse(cart) : [],
    };
  },

  setup() {
    let user = JSON.parse(localStorage.getItem("credentials"));
    let userID = user.id;

    //get cart local storage
    let getcart = JSON.parse(localStorage.getItem("cart"));

    //find value of id
    let findvalue;
    if (getcart !== null) {
      findvalue = getcart.map((d) => {
        return d.products.values().next().value;
      });
    }

    return { userID, findvalue };
  },

  computed: {
    currency() {
      return new Intl.NumberFormat("en-US", {
        style: "currency",
        currency: "USD",
      }).format(13);
    },
  },

  methods: {
    //post methods
    async addToCart(props) {
      //item to store
      const item = {
        id: props,
        quantity: this.quantity,
      };

      try {
        const response = await axios.post("/carts/add", {
          userId: this.userID,
          products: [item],
        });
        //to found the same id
        let found;
        if (this.cart.length > 0) {
          found = this.cart
            .map((d) => {
              return d.products.values().next().value;
            })
            .find((product) => product.id == item.id);
        }

        //condition if there's the same id
        if (found) {
          found.quantity++;
          let q = found.quantity;
          found.total = found.price * q;
        } else {
          if (this.cart.length < 0) {
            this.cart.push(response.data);
          } else {
            this.cart.push(response.data);
          }
        }

        //response
        localStorage.setItem("cart", JSON.stringify(this.cart));
      } catch (error) {
        console.log(error);
      }
    },

    //put methods
    decrement(item) {
      let found;
      found = this.cart
        .map((d) => {
          return d.products.values().next().value;
        })
        .find((product) => product.id == item.id);

      //found cart index
      let foundcart;
      foundcart = this.cart
        .map((d) => {
          return d.products.values().next().value;
        })
        .map((d) => {
          return d.id;
        })
        .findIndex((d) => d === item.id);

      if (found.quantity > 1) {
        found.quantity--;
        found.total = item.price * found.quantity;
      } else if (found.quantity == 1) {
        this.cart.splice(foundcart, 1);
      }
      localStorage.setItem("cart", JSON.stringify(this.cart));
    },

    increment(item) {
      let found;
      found = this.cart
        .map((d) => {
          return d.products.values().next().value;
        })
        .find((product) => product.id == item.id);
      if (found) {
        found.quantity++;
        let q = found.quantity;
        found.total = found.price * q;
      }
      localStorage.setItem("cart", JSON.stringify(this.cart));
    },
  },

  created() {
    this.category = this.$route.params.category;
    axios
      .get(`products/category/${this.category}`)
      .then((res) => {
        this.products = res.data.products;
      })
      .catch((e) => {
        console.log(e);
      });
  },
};
</script>
